# SAM_DATA_RESTORE

NAME
SYNOPSIS
DESCRIPTION
RETURN VALUE
ERRORS
SEE ALSO

## NAME

sam_data_restore − Restore previously saved user data

## SYNOPSIS

#include <corosync/sam.h>

cs_error_t sam_data_restore (void *data, size_t size);

## DESCRIPTION

The sam_data_restore function is used to restore data, previously saved by calling sam_data_store(3). Such data survives between instances.

The data parameter is pointer to memory initialized by caller. Stored data are copied there. This also means, that caller is responsible for freeing memory.

The size parameter is length of data. This one must be at least same length as previously stored data otherwise error is returned. Parameter can be larger but only stored data size bytes are changed.

Use sam_data_getsize(3) to find out length of stored data.

## RETURN VALUE

This call return CS_OK value if successful, otherwise and error is returned.

## ERRORS

CS_ERR_BAD_HANDLE

component was not initialized by calling sam_initialize(3) or it was finalized.

CS_ERR_INVALID_PARAM

data parameter is NULL or size is less then currently stored data length

## SEE ALSO

sam_data_getsize(3), sam_data_store(3)

CS_ERR_TRY_AGAIN Resource temporarily unavailable

CS_ERR_INVALID_PARAM Invalid argument

CS_ERR_ACCESS Permission denied

CS_ERR_LIBRARY The connection failed

CS_ERR_INTERRUPT System call interrupted by a signal

CS_ERR_NOT_SUPPORTED The requested protocol/functionality not supported

CS_ERR_MESSAGE_ERROR Incorrect auth message received

CS_ERR_NO_MEMORY Not enough memory to complete the requested task